<template>
	<div class="api-key-chip d-inline-flex">
		<v-chip close @click:close="showConfirmationDialog = true">
			{{ apiKey.label }}
		</v-chip>

		<confirm-dialog
			v-model="showConfirmationDialog"
			:title="`Revoke API key: ${apiKey.label}`"
			:error="hasError ? error : undefined"
			:loading="isLoading"
			button="Revoke Key"
			button-color="error"
			persistent
			@cleanup="clearError"
			@confirm="handleConfirmRevoke"
		>
			<p class="mt-0 mb-4">
				You will no longer be able to recover this API key once you revoke. Are you sure you want to revoke the api key:
				<strong>{{ apiKey.label }}</strong
				>?
			</p>
			<ul>
				<li>Revoking an api key is irreversible.</li>
				<li>Any applications using the api key will stop working with Soilstack.</li>
				<li>If you believe your api key has been compromised, you should revoke it and generate a new one.</li>
			</ul>
		</confirm-dialog>
	</div>
</template>

<script lang="ts">
import { computed, defineComponent, ref } from '@vue/composition-api';
import ConfirmDialog from '@/components/dialog/ConfirmDialog.vue';
import { useRevokeApiKey } from '@/store/modules/apiKeys';
import { ApiKey } from '@/store/types';

export default defineComponent({
	components: { ConfirmDialog },
	props: {
		apiKey: {
			type: Object as () => ApiKey,
			required: true,
		},
	},
	emits: ['revoke'],
	setup(props, { root }) {
		const showConfirmationDialog = ref<boolean>(false);
		const { revokeApiKey, clearError, isLoading, hasError, error: revokeError } = useRevokeApiKey(root.$store);

		const error = computed<string>(
			() =>
				revokeError.value?.response?.data?.message ||
				'An error occurred while attempting to revoke the API key. Please try again.'
		);

		const handleConfirmRevoke = async () => {
			clearError();

			const success = await revokeApiKey(props.apiKey.id);

			if (success) {
				root.$store.dispatch('users/getUsers');
				showConfirmationDialog.value = false;
			}
		};

		return {
			showConfirmationDialog,
			isLoading,
			hasError,
			error,
			clearError,
			handleConfirmRevoke,
		};
	},
});
</script>

<style>
.api-key-chip:not(:first-child) {
	margin-left: 8px;
}

.api-key-chip {
	margin-bottom: 4px;
}
</style>
